package com.unipi.talepis.protal20234;

public class Main {
    public static void main(String[] args) {
        System.out.println(Thread.currentThread().getName());
        Thread thread = new Thread(){
            @Override
            public void run() {
                System.out.println("Hi from "+Thread.currentThread().getName());
            }
        };
        thread.start();
        Thread thread2 =
                new Thread(() -> System.out.println("Hi from "+Thread.currentThread().getName()));
        thread2.start();
        Runnable r = new Runnable() {
            @Override
            public void run() {
                try {
                    thread2.join();
                } catch (InterruptedException e) {
                    throw new RuntimeException(e);
                }
                System.out.println("Hi from runnable");
            }
        };
        new Thread(r).start();
        Runnable r2 = () -> System.out.println("Hi from runnable2");
        new Thread(r2).start();
        new Thread(()-> System.out.println("Hi from one line thread!")).start();
    }
}